$colorValues: (
    'white': 'colors.gray.900',
    'gray-50': 'colors.gray.950',
    'gray-100': 'colors.gray.800',
    'gray-200': 'colors.gray.700',
    'gray-300': 'colors.gray.600',
    'gray-400': 'colors.gray.500',
    'gray-500': 'colors.gray.400',
    'gray-600': 'colors.gray.300',
    'gray-700': 'colors.gray.200',
    'gray-800': 'colors.gray.100',
    'gray-900': 'colors.gray.50',
    'black': 'colors.white'
);

:root.dark {
    @layer components {
        input:not([class*="dark:"]) {
            background-color: theme('colors.gray.800');
        }
        select:not([class*="dark:"]) {
            background-color: theme('colors.gray.800');
        }
        textarea:not([class*="dark:"]) {
            background-color: theme('colors.gray.800');
        }
        .select2-selection textarea {
            background-color: transparent;
        }
        .select2-search input {
            background-color: transparent;
        }
    }

    @layer utilities {
        @each $originalValue, $darkColor in $colorValues {
            .text-#{$originalValue}:not([class*="dark:"]) {
                color: theme($darkColor);
            }
            .bg-#{$originalValue}:not([class*="dark:"]) {
                background-color: theme($darkColor);
            }
            .border-#{$originalValue}:not([class*="dark:"]) {
                border-color: theme($darkColor);
            }
            .ring-#{$originalValue}:not([class*="dark:"]) {
                --tw-ring-color: $darkColor;
            }
        }
    }

    --colors-white: theme('colors.gray.900');
    --colors-gray-50: theme('colors.gray.950');
    --colors-gray-100: theme('colors.gray.800');
    --colors-gray-200: theme('colors.gray.700');
    --colors-gray-300: theme('colors.gray.600');
    --colors-gray-400: theme('colors.gray.500');
    --colors-gray-500: theme('colors.gray.400');
    --colors-gray-600: theme('colors.gray.300');
    --colors-gray-700: theme('colors.gray.200');
    --colors-gray-800: theme('colors.gray.100');
    --colors-gray-900: theme('colors.gray.50');
    --colors-black: theme('colors.white');
}

:root.dark {
    /* Helper variables to avoid duplication in the colors. */
    --ck-custom-background: hsl(270, 1%, 29%);
    --ck-custom-foreground: hsl(255, 3%, 18%);
    --ck-custom-border: hsl(300, 1%, 22%);
    --ck-custom-white: hsl(0, 0%, 100%);

    /* -- Overrides generic colors. ------------------------------------------------------------- */
    --ck-color-base-foreground: var(--ck-custom-background);
    --ck-color-text: hsl(0, 0%, 98%);
    --ck-color-shadow-drop: hsla(0, 0%, 0%, 0.2);
    --ck-color-shadow-inner: hsla(0, 0%, 0%, 0.1);

    /* -- Overrides the default .ck-button class colors. ---------------------------------------- */
    --ck-color-button-default-background: var(--ck-custom-background);
    --ck-color-button-default-hover-background: hsl(270, 1%, 22%);
    --ck-color-button-default-active-background: hsl(270, 2%, 20%);
    --ck-color-button-default-active-shadow: hsl(270, 2%, 23%);
    --ck-color-button-default-disabled-background: var(--ck-custom-background);

    --ck-color-button-on-background: var(--ck-custom-foreground);
    --ck-color-button-on-hover-background: hsl(255, 4%, 16%);
    --ck-color-button-on-active-background: hsl(255, 4%, 14%);
    --ck-color-button-on-active-shadow: hsl(240, 3%, 19%);
    --ck-color-button-on-disabled-background: var(--ck-custom-foreground);

    /* -- Overrides the default .ck-dropdown class colors. -------------------------------------- */
    --ck-color-dropdown-panel-background: var(--ck-custom-background);
    --ck-color-dropdown-panel-border: var(--ck-custom-foreground);

    /* -- Overrides the default .ck-splitbutton class colors. ----------------------------------- */
    --ck-color-split-button-hover-background: var(--ck-color-button-default-hover-background);
    --ck-color-split-button-hover-border: var(--ck-custom-foreground);

    /* -- Overrides the default .ck-input class colors. ----------------------------------------- */
    --ck-color-input-background: var(--ck-custom-background);
    --ck-color-input-border: hsl(257, 3%, 43%);
    --ck-color-input-text: hsl(0, 0%, 98%);
    --ck-color-input-disabled-background: hsl(255, 4%, 21%);
    --ck-color-input-disabled-border: hsl(250, 3%, 38%);
    --ck-color-input-disabled-text: hsl(0, 0%, 78%);

    /* -- Overrides the default .ck-labeled-field-view class colors. ---------------------------- */
    --ck-color-labeled-field-label-background: var(--ck-custom-background);

    /* -- Overrides the default .ck-list class colors. ------------------------------------------ */
    --ck-color-list-background: var(--ck-custom-background);
    --ck-color-list-button-hover-background: var(--ck-custom-foreground);
    --ck-color-list-button-on-background: var(--colors-gray-300);
    --ck-color-list-button-on-text: var(--ck-custom-white);

    /* -- Overrides the default .ck-balloon-panel class colors. --------------------------------- */

    --ck-color-panel-background: var(--ck-custom-background);
    --ck-color-panel-border: var(--ck-custom-border);

    /* -- Overrides the default .ck-toolbar class colors. --------------------------------------- */

    --ck-color-toolbar-background: var(--ck-custom-background);
    --ck-color-toolbar-border: var(--ck-custom-border);

    /* -- Overrides the default .ck-tooltip class colors. --------------------------------------- */

    --ck-color-tooltip-background: hsl(252, 7%, 14%);
    --ck-color-tooltip-text: hsl(0, 0%, 93%);

    /* -- Overrides the default colors used by the ckeditor5-image package. --------------------- */

    --ck-color-image-caption-background: hsl(0, 0%, 97%);
    --ck-color-image-caption-text: hsl(0, 0%, 20%);

    /* -- Overrides the default colors used by the ckeditor5-widget package. -------------------- */

    --ck-color-widget-blurred-border: hsl(0, 0%, 87%);
    --ck-color-widget-hover-border: hsl(43, 100%, 68%);
    --ck-color-widget-editable-focus-background: var(--ck-custom-white);

    /* -- Overrides the default colors used by the ckeditor5-link package. ---------------------- */

    --ck-color-link-default: var(--colors-gray-400);
    --ck-color-list-button-on-background-focus: var(--colors-gray-400);

    --ck-color-focus-border: var(--colors-gray-300);
    --ck-color-base-border: var(--colors-gray-300);
    --ck-color-base-background: var(--colors-gray-100);
}
